<template>
  <div class="trunk pagination">
    <button
      class="pagination_arrow pagination_before"
      :title="$t('catalog.prev')"
      :disabled="isPreviousButtonDisabled"
      @click="pageChangeHandle('previous')"
    ></button>
    <div class="pagination_list">
      <PaginationTrigger
        v-for="paginationTrigger in paginationTriggers"
        :key="paginationTrigger"
        :class="{
          'pagination_page pagination_page--active':
            paginationTrigger === selectedPage
        }"
        :page-number="paginationTrigger"
        @loadPage="pageChangeHandle"
      />
    </div>
    <button
      class="pagination_arrow pagination_after"
      :title="$t('catalog.next')"
      :disabled="isNextButtonDisabled"
      @click="pageChangeHandle('next')"
    ></button>
  </div>
</template>

<script>
import PaginationTrigger from './PaginationTrigger'

export default {
  components: { PaginationTrigger },
  props: {
    currentPage: {
      type: Number,
      required: true
    },
    itemsPerPage: {
      type: Number,
      required: true
    },
    totalPage: {
      type: Number,
      required: true
    },
    params: {
      type: Object,
      required: false,
      default: undefined
    }
  },
  data() {
    return {
      visiblePagesCount: 6,
      selectedPage: 0
    }
  },
  computed: {
    isPreviousButtonDisabled() {
      return this.selectedPage === 1
    },
    isNextButtonDisabled() {
      return this.selectedPage === this.totalPage
    },
    paginationTriggers() {
      const currentPage = this.selectedPage
      const totalPage = this.totalPage
      const visiblePagesCount = this.visiblePagesCount
      const visiblePagesThreshold = Math.ceil((visiblePagesCount - 1) / 2)
      const paginationTriggersArray = Array(
        totalPage <= visiblePagesCount ? totalPage : visiblePagesCount - 1
      ).fill(0)

      if (currentPage <= visiblePagesThreshold + 1) {
        paginationTriggersArray[0] = 1
        const paginationTriggers = paginationTriggersArray.map(
          (paginationTrigger, index) => {
            return paginationTriggersArray[0] + index
          }
        )
        paginationTriggers.push(totalPage)
        return new Set(paginationTriggers)
      }

      if (currentPage >= totalPage - visiblePagesThreshold + 1) {
        const paginationTriggers = paginationTriggersArray.map(
          (paginationTrigger, index) => {
            return totalPage - index
          }
        )
        paginationTriggers.reverse()
        return paginationTriggers
      }

      paginationTriggersArray[0] = currentPage - visiblePagesThreshold + 1
      const paginationTrigger = paginationTriggersArray.map(
        (paginationTrigger, index) => {
          return paginationTriggersArray[0] + index
        }
      )

      paginationTrigger.unshift(1, '...')
      paginationTrigger.push('...', totalPage)

      return paginationTrigger
    }
  },
  watch: {
    currentPage() {
      this.selectedPage = this.currentPage
    }
  },
  mounted() {
    this.selectedPage = this.currentPage
  },
  methods: {
    async pageChangeHandle(value) {
      switch (value) {
        case 'next':
          this.selectedPage += 1
          break
        case 'previous':
          this.selectedPage -= 1
          break
        default:
          this.selectedPage = value
      }

      const from =
        this.selectedPage === 1
          ? 0
          : this.selectedPage * this.itemsPerPage - (this.itemsPerPage - 1)
      const limit = [from, this.itemsPerPage]

      if (this.params) {
        const { series } = await this.fetch.POST(this.params.url, {
          reference: this.params.reference,
          shelf: this.params.shelf,
          limit: limit,
          count: this.params.count
        })
        this.series = series.series

        this.$emit('updateSeries', this.series)
      }

      this.$emit('updatePage', this.selectedPage)
    }
  }
}
</script>

<style
  lang="scss"
  src="~/assets/scss/v7/components/organisms/pagination/_pagination.scss"
></style>

<style scoped lang="scss">
.pagination_arrow {
  cursor: pointer;
}
</style>
